/////////////////////////////////////////////////////////////////////////////////////
// This file is part of the PngOptimizer application
// Copyright (C) 2002/2013 Hadrien Nilsson - psydk.org
// For conditions of distribution and use, see copyright notice in PngOptimizer.h
/////////////////////////////////////////////////////////////////////////////////////

#ifndef PO_DLGSCREENSHOTSOPTIONS_H
#define PO_DLGSCREENSHOTSOPTIONS_H

class DlgScreenshotsOptions : public Dialog
{
public:
	// Public settings [in,out]
	bool m_bUseDefaultDir;
	chustd::String m_strCustomDir;
	bool m_bMaximizeCompression;
	bool m_bAskForFileName;

public:
	int DoModal(HWND hParent);

	DlgScreenshotsOptions();

protected:
	// Controls
	CheckButton	m_chkDefault;
	CheckButton	m_chkCustom;
	EditBox	    m_editDirectory;
	Button      m_btBrowse;

	CheckButton	m_chkMaximizeCompression;
	CheckButton	m_chkAskForFilename;

protected:
	virtual LRESULT DlgProc(UINT nMsg, WPARAM wParam, LPARAM lParam);
	virtual BOOL OnInitDialog(HWND hCtl, LPARAM lParam);

	void OnCheckDefault();
	void OnCheckCustom();
	void OnButtonBrowse();

	// Returns true if no problem
	bool StoreControlValues();
	void SyncControlStates();
};

#endif // ndef PO_DLGSCREENSHOTSOPTIONS_H
