///////////////////////////////////////////////////////////////////////////////
// This file is part of the chustd library
// Copyright (C) 2005/2013 ChuTeam
// For conditions of distribution and use, see copyright notice in chustd.h
///////////////////////////////////////////////////////////////////////////////

#ifndef CHUSTD_SEMAPHORE_H
#define CHUSTD_SEMAPHORE_H

namespace chustd {

class Semaphore
{
public:
	Semaphore();
	~Semaphore();

	bool Create(int initialCount = 0);
	void Close();

	bool Increment(int count = 1);
	bool Decrement();
	int  Wait(int timeout = -1);

private:
	void* m_handle;
};

} // namespace chustd

#endif
