///////////////////////////////////////////////////////////////////////////////
// This file is part of the chustd library
// Copyright (C) 2005/2013 ChuTeam
// For conditions of distribution and use, see copyright notice in chustd.h
///////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "System.h"
#include "String.h"
#include "File.h"

using namespace chustd;

uint32 System::GetTime()
{
#ifdef WIN32
	return GetTickCount();
#elif CHUOS
	return chuos_GetSystemTime();
#endif
}

String System::GetFontsDirectory()
{
#ifdef WIN32
	wchar szPath[MAX_PATH];
	if( SHGetSpecialFolderPathW(NULL, szPath, CSIDL_FONTS, FALSE) )
	{
		return String(szPath);
	}
#endif
	return String();	
}

String System::GetApplicationDataDirectory()
{
#ifdef WIN32
	wchar szPath[MAX_PATH];
	if( SHGetSpecialFolderPathW(NULL, szPath,CSIDL_APPDATA, TRUE) )
	{
		return String(szPath);
	}
#endif
	return String();
}
