///////////////////////////////////////////////////////////////////////////////
// This file is part of the chustd library
// Copyright (C) 2005/2013 ChuTeam
// For conditions of distribution and use, see copyright notice in chustd.h
///////////////////////////////////////////////////////////////////////////////

#ifndef CHUSTD_TCPSERVER_H
#define CHUSTD_TCPSERVER_H

#include "Socket.h"

namespace chustd {

// Waits for TCP network clients. The process is blocking.
class TcpServer
{
public:
	// Starts the server
	bool Start(uint16 port);

	// Waits for an incoming connection
	bool Accept(Socket& sock);

	// Stops the server
	void Stop();
private:
	Socket m_sock;
};

} // namespace chustd

#endif // ndef CHUSTD_TCPSERVER_H
