#include "stdafx.h"

TEST(File, GetDrive)
{
	String str0 = File::GetDrive(L"abc");
	ASSERT_TRUE(str0.IsEmpty());

	String str1 = File::GetDrive(L"/abc");
	ASSERT_TRUE(str1.IsEmpty());

	String str2 = File::GetDrive(L"\\abc");
	ASSERT_TRUE(str2.IsEmpty());

	String str3 = File::GetDrive(L"System:abc");
	ASSERT_TRUE(str3 == L"System");

	String str4 = File::GetDrive(L"System:/abc");
	ASSERT_TRUE(str4 == L"System");
}

TEST(File, Open)
{
	// Mix slash and backslash
	String strPath = Process::GetCurrentDirectory();
	strPath = FilePath::Combine(strPath, L"testfile.bin");
	
	File file0;
	ASSERT_TRUE(file0.Open(strPath, File::modeWrite));
	file0.Close();

	ASSERT_TRUE( File::Delete(strPath));
}

TEST(File, Append)
{
	String strPath = Process::GetCurrentDirectory();
	strPath = FilePath::Combine(strPath, L"testfile.txt");
	
	if( File::Exists(strPath) )
	{
		ASSERT_TRUE( File::Delete(strPath));
	}

	File file0;
	for(int32 i = 0; i < 4; ++i)
	{
		ASSERT_TRUE( file0.Open(strPath, File::modeAppend) );
		ASSERT_TRUE( file0.WriteString(L"A", TextEncoding::Windows1252()) == 1 );
		file0.Close();
	}

	uint32 nContent;
	ASSERT_TRUE( file0.Open(strPath) );
	ASSERT_TRUE( file0.Read32(nContent) );

	// No more data
	uint8 buf[10];
	ASSERT_EQ( 0, file0.Read(buf, 0) );
	ASSERT_EQ( 0, file0.Read(buf, 10) );

	file0.Close();

	ASSERT_TRUE( nContent == 'AAAA' );
	
	ASSERT_TRUE( File::Delete(strPath));
}
